/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package cd.hologram.erecettesvg.sql;

/**
 *
 * @author emmanuel.tsasa
 */
public class SQLQueryAssujettissement {

    public static String SELECT_TYPES_BIENS = "SELECT * FROM T_TYPE_BIEN WITH(READPAST) WHERE ETAT = 1";

    public static String SELECT_TYPES_COMPLEMENTS_BIENS = "SELECT * FROM T_TYPE_COMPLEMENT_BIEN WITH(READPAST) "
            + " WHERE TYPE_BIEN = ?1 AND ETAT = 1";

    public static String F_NEW_BIEN = "F_NEW_BIEN_WEB";
    public static String F_NEW_BIEN_IMMOBILIER_WEB = "F_NEW_BIEN_IMMOBILIER_WEB";

    public static String SELECT_PERIODE_DECLARATION_BY_CODE = "SELECT * FROM T_PERIODE_DECLARATION WITH (READPAST) WHERE ID = ?1";

    public static String UPDATE_BIEN = ":UPDATE T_BIEN SET INTITULE = ?1, DESCRIPTION = ?2, TYPE_BIEN =?3, FK_ADRESSE_PERSONNE = ?4, FK_TARIF = ?5 WHERE ID = ?6";

    public static String UPDATE_BIEN_IMMOBILIER = ":UPDATE T_BIEN SET INTITULE = ?1, DESCRIPTION = ?2, TYPE_BIEN =?3, FK_ADRESSE_PERSONNE = ?4, FK_USAGE_BIEN = ?5,FK_TARIF = ?6,FK_COMMUNE = ?7 WHERE ID = ?8";

    public static String UPDATE_COMPLEMENT_BIENS = ":UPDATE T_COMPLEMENT_BIEN SET VALEUR = ?1, DEVISE = ?2 WHERE ID = ?3";

    public static String F_NEW_COMPLEMENT_BIEN = ":EXEC F_NEW_COMPLEMENT_BIEN ?1,'%s',?2,?3,?4";

    public static String F_NEW_COMPLEMENT_BIEN2 = ":EXEC F_NEW_COMPLEMENT_BIEN ?1,?2,?3,?4,?5";

    public static String F_NEW_RETRAIT_DECLARATION = ":EXEC F_NEW_RETRAIT_DECLARATION ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16";
    public static String F_NEW_RETRAIT_DECLARATION_X = ":EXEC F_NEW_RETRAIT_DECLARATION_X ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16";
    public static String F_NEW_RETRAIT_DECLARATION_PENALITE = ":EXEC F_NEW_RETRAIT_DECLARATION_PENALITE ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16";
    public static String F_NEW_RETRAIT_DECLARATION_2 = ":EXEC F_NEW_RETRAIT_DECLARATION_2 ?1,?2,?3,?4,?5,?6,?7,?8,?9,?10,?11,?12,?13,?14,?15,?16,?17,?18";

    public static String UPDATE_COMPLEMENT_BIEN = "UPDATE T_COMPLEMENT_BIEN SET VALEUR = ?1, DEVISE = ?2 WHERE BIEN = ?3 AND TYPE_COMPLEMENT = ?4";

    public static String SELECT_BIENS_OF_PERSONNE = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) INNER JOIN T_BIEN B WITH (READPAST) ON A.BIEN = B.ID  WHERE A.PERSONNE = ?1 AND A.ETAT = 1"
            + " AND B.TYPE_BIEN IN (SELECT TYPE_BIEN FROM T_TYPE_BIEN_SERVICE WHERE SERVICE = ?2 AND ETAT = 1)";

    public static String SELECT_BIENS_OF_PERSONNE_V3 = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) WHERE A.PERSONNE = ?1 AND A.ETAT = 1";
    
    public static String SELECT_BIENS_OF_PERSONNE_V4 = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) WHERE A.PERSONNE = ?1 AND A.ETAT = 1 \n"
            + "	AND A.BIEN IN (SELECT B.ID FROM T_BIEN B WITH (READPAST) WHERE B.TYPE_BIEN \n"
            + "	IN (SELECT DISTINCT TYPE_BIEN FROM T_TYPE_BIEN_SERVICE WITH (READPAST) WHERE SERVICE = ?2 AND ETAT = 1) AND B.FK_TARIF = ?3) ";

    public static String SELECT_BIENS_OF_PERSONNE_V2 = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) "
            + " WHERE A.PERSONNE = ?1 AND A.ETAT = 1 AND A.BIEN IN (SELECT B.ID FROM T_BIEN B WITH (READPAST) "
            + " WHERE B.TYPE_BIEN IN (%s))";

    public static String SELECT_BIENS_BY_PERSONNE_AND_ID_BIEN = "SELECT * FROM T_ACQUISITION WITH (READPAST) WHERE PERSONNE = ?1 AND BIEN = ?2 AND ETAT = 1";

    public static String SELECT_RESPONSABLE_BIEN = "SELECT * FROM T_PERSONNE WITH (READPAST) WHERE CODE IN (SELECT DISTINCT PERSONNE FROM T_ACQUISITION WHERE BIEN = ?1 AND PROPRIETAIRE = 1 AND ETAT = 1)";

    //public static String SELECT_MOTO_SOUS_CONTRAT_BY_ID = "SELECT CV.* FROM T_CONDUCTEUR_VEHICULE CV WITH (READPAST) WHERE CV.BIEN = ?1 AND CV.ETAT = 1";
    public static String SELECT_PALIER_BY_AB_TARIF_AND_TYPE_PERSONNE = "SELECT * from T_PALIER WITH (READPAST) \n"
            + "WHERE ARTICLE_BUDGETAIRE = ?1 AND TARIF = ?2 AND ETAT = 1 AND TYPE_PERSONNE IN (?3)";

    public static String SELECT_PALIER_BY_AB_TARIF_AND_TYPE_PERSONNE_V2 = "SELECT * from T_PALIER WITH (READPAST) \n"
            + "WHERE ARTICLE_BUDGETAIRE = ?1 AND TARIF = ?2 AND ETAT = 1 AND TYPE_PERSONNE = ?3 AND FK_ENTITE_ADMINISTRATIVE = ?4 AND FK_TYPE_BIEN = ?5";

    public static String F_NEW_ACQUISITION_BIEN = "EXEC F_NEW_ACQUISITION_BIEN ?1,?2,?3,?4,?5,?6,?7";

    public static String SELECT_AB_COMPLEMENT_BY_BIEN = "SELECT * FROM T_AB_COMPLEMENT_BIEN WITH (READPAST) WHERE TYPE_COMPLEMENT_BIEN "
            + " IN (SELECT TCB.CODE FROM T_TYPE_COMPLEMENT_BIEN TCB WITH (READPAST) WHERE "
            + " TCB.TYPE_BIEN = (SELECT B.TYPE_BIEN FROM T_BIEN B WITH (READPAST) WHERE B.ID = ?1 AND B.ETAT = 1 )AND TCB.ETAT = 1) AND ETAT = 1";

    public static String SELECT_COMPLEMENT_BIEN_BY_TYPE_COMPLEMENT_AND_BIEN = "SELECT * FROM T_COMPLEMENT_BIEN WITH (READPAST) WHERE TYPE_COMPLEMENT =?1 AND BIEN =?2 AND ETAT= 1";

    public static String SELECT_LIST_COMPLEMENT_BIEN_BY_BIEN = "SELECT * FROM T_COMPLEMENT_BIEN WITH (READPAST) WHERE BIEN =?1 AND ETAT= 1";

    public static String SELECT_PERIODICITES = "SELECT * FROM T_PERIODICITE WITH (READPAST) WHERE ETAT = 1 ORDER BY INTITULE";

    public static String SELECT_PALIERS_BY_AB = "SELECT * FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE = ?1 AND ETAT = 1 AND TYPE_PERSONNE = ?2";
    
    public static String SELECT_PALIERS_BY_AB_V2 = "SELECT * FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE = ?1 AND ETAT = 1";

    public static String SELECT_PALIERS_BY_AB_1 = "SELECT * FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE = ?1 AND ETAT = 1 AND TYPE_PERSONNE = ?2";

    public static String SELECT_PALIERS_BY_AB_TARIF = "SELECT * FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE = ?1 AND TARIF = ?2 AND ETAT = 1 AND TYPE_PERSONNE = ?3 AND FK_ENTITE_ADMINISTRATIVE = ?4";

    public static String SELECT_PALIERS_BY_AB_FORME_JURIDIQUE = "SELECT * FROM T_PALIER WITH (READPAST) WHERE ARTICLE_BUDGETAIRE = ?1 AND (TYPE_PERSONNE = ?2 OR TYPE_PERSONNE = '*') AND ETAT = 1";

    public static String F_NEW_ASSUJETISSEMENT = "F_NEW_ASSUJETISSEMENT";

    public static String F_NEW_ASSIGNATION_BUDGETAIRE = "F_NEW_ASSIGNATION_BUDGETAIRE";

    public static String F_NEW_PERIODE_DECLARATION = ":EXEC F_NEW_PERIODE_DECLARATION '%s',?1,?2,?3,?4,?5";
    public static String F_ADD_NEW_PERIODE_DECLARATION = ":EXEC F_NEW_PERIODE_DECLARATION ?1,?2,?3,?4,?5,?6";

    public static String F_NEW_PERIODE_DECLARATION_V2 = ":EXEC F_NEW_PERIODE_DECLARATION ?1,?2,?3,?4,?5";

    public static String F_NEW_PERIODE_DECLARATION_V3 = ":EXEC F_NEW_PERIODE_DECLARATION ?1,?2,?3,?4,?5,?6";

    public static String SELECT_EXISTED_ASSUJETTI = "SELECT * FROM  T_ASSUJETI WITH (READPAST) WHERE BIEN =?1 "
            + " AND ARTICLE_BUDGETAIRE =?2 AND PERSONNE =?3 AND ETAT = 1";

    public static String SELECT_EXISTED_ASSUJETTI_SANS_BIEN = "SELECT * FROM  T_ASSUJETI WITH (READPAST) "
            + " WHERE ARTICLE_BUDGETAIRE =?1 AND PERSONNE = ?2 AND ETAT=1";

    public static String LIST_ARTICLE_BUDGETAIRE_ASSUJETISSABLE = "SELECT * FROM T_ARTICLE_BUDGETAIRE WITH (READPAST) "
            + " WHERE ASSUJETISSABLE = 1 AND INTITULE LIKE ?1 AND ETAT = 1";

    public static String LIST_ASSUJETTISSEMENT_BY_PERSONNE = "SELECT A.* FROM T_ASSUJETI A WITH (READPAST) INNER JOIN T_BIEN B WITH (READPAST) ON A.BIEN = B.ID WHERE A.PERSONNE = ?1 AND A.ETAT = 1"
            + " AND B.TYPE_BIEN IN (SELECT TYPE_BIEN FROM T_TYPE_BIEN_SERVICE WHERE SERVICE = ?2 AND ETAT = 1)";

    public static String LIST_ASSUJETTISSEMENT_BY_PERSONNE_V2 = "SELECT A.* FROM T_ASSUJETI A WITH (READPAST) INNER JOIN T_BIEN B WITH (READPAST) ON A.BIEN = B.ID WHERE A.PERSONNE = ?1 AND A.ETAT = 1";

    public static String LIST_ASSUJETTISSEMENT_BY_PERSONNE_V3 = "SELECT A.* FROM T_ASSUJETI A WITH (READPAST) WHERE A.PERSONNE = ?1 AND A.ETAT = 1";

    public static String LIST_PERIODE_DECLARATION_DISPO = "SELECT * FROM T_PERIODE_DECLARATION WITH (READPAST) WHERE ASSUJETISSEMENT = ?1 AND (NOTE_CALCUL IS NULL OR NOTE_CALCUL = '') AND ETAT = 1";

    public static String UPDATE_DATE_FIN_ASSUJETTISSEMENT = ":UPDATE T_ASSUJETI SET DATE_FIN = ?1 WHERE ID = ?2";

    public static String DESACTIVATE_ASSUJETTISSEMENT = "UPDATE T_ASSUJETI SET ETAT = 0 WHERE ID = ?1";

    public static String SELECT_BIEN_BY_ID = "SELECT * FROM T_BIEN WITH (READPAST) WHERE ID = ?1 AND ETAT = 1";

    public static String SELECT_AB_COMPLEMENT_BIEN_BY_AB = "SELECT * FROM T_AB_COMPLEMENT_BIEN WITH (READPAST) "
            + " WHERE ARTICLE_BUDGETAIRE = ?1 AND ETAT = 1";

    public static String SELECT_BIEN_EN_LOCATION = "SELECT * FROM T_ACQUISITION WHERE BIEN = ?1 AND PERSONNE <> ?2 AND ETAT = 1";

    public static String LIST_ARTICLE_BUDGETAIRE_ASSUJETISSABLE_BY_SITE = "select * from T_ARTICLE_BUDGETAIRE a WITH (READPAST) \n"
            + " where a.CODE IN (SELECT FK_AB FROM T_SITE_AB WITH (READPAST) WHERE ETAT = 1 AND FK_SITE = ?1) AND ASSUJETISSABLE = 1 and a.ETAT = 1 AND CODE in (select FK_AB from T_ENTITE_SERVICE_AB WITH (READPAST) \n"
            + " where etat = 1 and FK_ENTITE_SERVICE in (select id from T_ENTITE_SERVICE WITH (READPAST) where etat = 1 and FK_SERVICE = ?2 and FK_ENTITE = ?3))";

    public static String LIST_ARTICLE_BUDGETAIRE_ASSUJETISSABLE_BY_ENTITE_SERVICE = "select * from T_ARTICLE_BUDGETAIRE a WITH (READPAST) \n"
            + " where (a.INTITULE LIKE ?1 OR a.CODE_OFFICIEL LIKE ?1) AND ASSUJETISSABLE = 1 and a.ETAT = 1 AND CODE in (select FK_AB from T_ENTITE_SERVICE_AB WITH (READPAST) \n"
            + " where etat = 1 and FK_ENTITE_SERVICE in (select id from T_ENTITE_SERVICE WITH (READPAST) where etat = 1 and FK_SERVICE = '%s' and FK_ENTITE = '%s'))";

    public static String SELECT_BIENS_MOBILIERS_OF_PERSONNE = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) "
            + " INNER JOIN T_BIEN B WITH (READPAST) ON A.BIEN = B.ID WHERE A.PERSONNE = ?1 "
            + " AND A.ETAT = 1 AND B.TYPE_BIEN IN (%s) AND B.ID NOT IN (SELECT DA.FK_BIEN FROM T_DETAILS_PREVISION_CREDIT DA "
            + " WITH (READPAST) WHERE DA.ETAT in (1,2) AND DA.FK_DETAIL_ASSUJETTISSEMENT IN (SELECT ID FROM T_DETAIL_ASSUJETTISSEMENT WITH (READPAST) "
            + " WHERE FK_PERSONNE = '%s' and ETAT = 1)) AND B.ID NOT IN (SELECT BIEN FROM T_DETAIL_ASSUJETTISSEMENT WITH (READPAST) "
            + " WHERE FK_PERSONNE = '%s')ORDER BY B.INTITULE";
    
    public static String SELECT_BIENS_MOBILIERS_OF_PERSONNE_FOR_PEAGE = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) "
            + " INNER JOIN T_BIEN B WITH (READPAST) ON A.BIEN = B.ID WHERE A.PERSONNE = ?1 "
            + " AND A.ETAT = 1 AND B.TYPE_BIEN IN (select TYPE_BIEN from T_TYPE_BIEN_SERVICE WITH (READPAST) where ETAT = 1 and TYPE = 1) AND B.ID NOT IN (SELECT DA.FK_BIEN FROM T_DETAILS_PREVISION_CREDIT DA "
            + " WITH (READPAST) WHERE DA.ETAT in (1,2) AND DA.FK_DETAIL_ASSUJETTISSEMENT IN (SELECT ID FROM T_DETAIL_ASSUJETTISSEMENT WITH (READPAST) "
            + " WHERE FK_PERSONNE = '%s' and ETAT = 1)) AND B.ID NOT IN (SELECT BIEN FROM T_DETAIL_ASSUJETTISSEMENT WITH (READPAST) "
            + " WHERE FK_PERSONNE = '%s')ORDER BY B.INTITULE";

    public static String SELECT_BIENS_MOBILIERS_OF_PERSONNEV2 = "SELECT A.* FROM T_ACQUISITION A WITH (READPAST) "
            + " INNER JOIN T_BIEN B WITH (READPAST) ON A.BIEN = B.ID WHERE A.PERSONNE = ?1 "
            + " AND A.ETAT = 1 AND B.TYPE_BIEN IN (%s) AND B.ID NOT IN (SELECT DA.BIEN FROM T_DETAIL_ASSUJETTISSEMENT DA "
            + " WITH (READPAST) WHERE DA.ETAT = 1 AND DA.FK_PERSONNE = '%s') ORDER BY B.INTITULE";

    public static String SELECT_TAXES_PEAGES = "SELECT * FROM T_ARTICLE_BUDGETAIRE WHERE CODE IN(%s) AND ETAT = 1";

    public static String SELECT_DETAIL_ASSUJETTISSEMENT_BIEN_BIEN = "SELECT * FROM T_DETAIL_ASSUJETTISSEMENT WITH (READPAST) WHERE BIEN = ?1 AND ETAT = 1";
    public static String SELECT_DETAIL_ASSUJETTISSEMENT_BIEN_BY_ASSUJETTI_AND_BIEN = "SELECT * FROM T_DETAIL_ASSUJETTISSEMENT WITH (READPAST) WHERE FK_PERSONNE = ?1 AND BIEN = ?2 AND ETAT = 1";

    //public static String SELECT_BIEN_BY_IMMATRICULATION = "SELECT * FROM T_BIEN WHERE ID IN (SELECT DISTINCT CB.BIEN FROM T_COMPLEMENT_BIEN CB WHERE CB.VALEUR = ?1 AND CB.TYPE_COMPLEMENT IN (%s) AND CB.ETAT = 1) AND ETAT = 1";
    public static String SELECT_BIEN_BY_IMMATRICULATION = "SELECT * FROM T_BIEN WHERE ID IN (SELECT DISTINCT CB.BIEN FROM T_COMPLEMENT_BIEN CB WHERE CB.VALEUR = ?1 AND CB.TYPE_COMPLEMENT IN (SELECT CODE FROM T_TYPE_COMPLEMENT_BIEN WHERE COMPLEMENT IN(?2,?3)) AND CB.ETAT = 1) AND ETAT = 1";

    public static String SELECT_DETAIL_ASSUJETTISSEMENT_BY_BIEN = "SELECT * FROM T_DETAIL_ASSUJETTISSEMENT WHERE BIEN = ?1 AND ETAT > 0";

    public static String SELECT_ACQUISITION_BY_BIEN = "SELECT * FROM T_ACQUISITION WHERE BIEN = ?1 AND PROPRIETAIRE = 1 AND ETAT = 1";

    public static String SELECT_PERSONNE_EXEMPTEE = "SELECT * FROM T_PERSONNE_EXEMPTEE WHERE PERSONNE = ?1 AND ETAT = 1";

    public static String SELECT_PREVISION_CREDIT_BY_ASSUJETTISSEMENT = "SELECT * FROM T_PREVISION_CREDIT WHERE ASSUJETTISSEMENT = ?1 AND ETAT = 1";

    public static String SELECT_DETAIL_PREVISION_CREDIT_BY_DETAIL_ASSUJETTISSEMENT = "SELECT * FROM T_DETAIL_PREVISION_CREDIT WHERE DETAIL_ASSUJETTISSEMENT = ?1 AND ETAT = 1";

    public static String SELECT_COMPLEMENT_PERSONNE = "SELECT * FROM T_COMPLEMENT WHERE PERSONNE = ?1 AND ETAT = 1";

    public static String SELECT_MOTO_SOUS_CONTRAT_BY_ID = "SELECT CV.* FROM T_CONDUCTEUR_VEHICULE CV WITH (READPAST) WHERE CV.BIEN = ?1 AND CV.ETAT = 1";

    public static String SELECT_VALEUR_PREDEFINIE = "SELECT * FROM T_VALEUR_PREDEFINIE WITH (READPAST) WHERE CODE = ?1 AND ETAT = 1";

    public static String F_NEW_DETAILS_ASSIGNATION_BUDGETAIRE = ":EXEC F_NEW_DETAILS_ASSIGNATION_BUDGETAIRE ?1,?2,?3,?4,?5,?6,?7";

    public static String UPDATE_MONTANT_ASSIGNE = "UPDATE T_DETAILS_ASSIGNATION_BUDGETAIRE SET MONTANT_ASSIGNE = ?1 WHERE ID = ?2";

    public static String UPDATE_ASSIGNATION_BUDGETAIRE = "UPDATE T_ASSIGNATION_BUDGETAIRE SET MONTANT_GLOBAL = ?1 WHERE ID = ?2";

    public static String SELECT_TYPES_BIEN_BY_SERVICE = "SELECT TB.* FROM T_TYPE_BIEN TB WITH(READPAST) WHERE ETAT = 1"
            + " AND TB.CODE IN (SELECT TBS.TYPE_BIEN FROM T_TYPE_BIEN_SERVICE TBS WITH(READPAST) "
            + " WHERE TBS.ETAT = 1 AND TBS.SERVICE = ?1) ORDER BY TB.INTITULE";

    public static String SELECT_TYPES_BIEN_BY_TYPE = "SELECT TB.* FROM T_TYPE_BIEN TB WITH(READPAST) WHERE ETAT = 1"
            + " AND TB.CODE IN (SELECT TBS.TYPE_BIEN FROM T_TYPE_BIEN_SERVICE TBS WITH(READPAST) "
            + " WHERE TBS.ETAT = 1 AND TBS.TYPE = ?1) ORDER BY TB.INTITULE";

    public static String F_NEW_TYPE_BIEN = "EXEC F_NEW_TYPE_BIEN ?1,?2, ?3,?4";

    public static String UPDATE_TYPE_BIEN = "UPDATE T_TYPE_BIEN SET INTITULE = ?1, CONTRACTUEL = ?2 WHERE CODE = ?3";

    public static String UPDATE_USAGE_BIEN = "UPDATE T_USAGE_BIEN SET INTITULE = ?1 WHERE ID = ?2";

    public static String DELETE_USAGE_BIEN = "UPDATE T_USAGE_BIEN SET ETAT = 0 WHERE ID = ?1";

    public static String INSERT_USAGE_BIEN = "INSERT INTO T_USAGE_BIEN (INTITULE,ETAT) VALUES (?1,1)";

    public static String DISABLE_TYPE_BIEN = "UPDATE T_TYPE_BIEN SET ETAT = 0 WHERE CODE = ?1";

    public static String SELECT_PALIERS_PEAGES = "SELECT * FROM T_PALIER WITH(READPAST) WHERE ARTICLE_BUDGETAIRE IN(%s) AND ETAT = 1";

    public static String SELECT_ACQUISITION_BY_PROPRIETAIRE = "SELECT * FROM T_ACQUISITION WITH(READPAST) WHERE PERSONNE = ?1 AND BIEN = ?2 AND PROPRIETAIRE = 1 AND ETAT = 1";

    public static String UPDATE_ACQUISITION = ":UPDATE T_ACQUISITION WITH (READPAST) SET ETAT = 0 WHERE ID = ?1";

    public static String INSERT_ACQUISITION = ":EXEC F_NEW_ACQUISITION_BIEN ?1,?2,?3,?4,?5,?6,?7";

}
